using PkmnLib.Dynamic.Models;

namespace PkmnLib.Dynamic.Events;

public class ExperienceGainEvent : IEventData
{
    public ExperienceGainEvent(IPokemon pokemon, uint previousExperience, uint newExperience)
    {
        Pokemon = pokemon;
        PreviousExperience = previousExperience;
        NewExperience = newExperience;
    }
    
    public IPokemon Pokemon { get; set; }
    public uint PreviousExperience { get; }
    public uint NewExperience { get; }


    /// <inheritdoc />
    public EventBatchId BatchId { get; init; }
}